'  10-bit PCM Player, plays stereo PCM (up to 16-bit) from a circular buffer
'  Copyright 2009 David Sloan
'  See end of file for terms of use.

VAR
  long  dacpars[5] 
  byte  running
  byte  cog

Pub start(Lpin, Rpin, pLeft, pRight, count)
  'max count == 14
  if count > 14
    abort(-1) 
  dacpars[0] := Lpin
  dacpars[1] := Rpin
  dacpars[2] := pLeft
  dacpars[3] := pRight
  dacpars[4] := count   
  if running <> 1
    cog := cognew(@dac, @dacpars)  
    running := 1 

pub stop
  if running == 1
    cogstop(cog)
    running := 0
    

DAT
org 0
              'retrieve parameters
dac           mov       time, par               'using time as temp var
              rdlong    dacLpin, time
              add       time, #4
              rdlong    dacRpin, time
              add       time, #4
              rdlong    pLbase, time
              add       time, #4
              rdlong    pRbase, time
              add       time, #4
              rdlong    pCount, time
              'set pin directions
              mov       time, #1
              shl       time, dacLpin
              or        dira, time
              mov       time, #1
              shl       time, dacRpin
              or        dira, time
              'set ctr state
              mov       ctra, ctrval
              movs      ctra, dacLpin
              mov       frqa, #1       'set counter to increment 1 each cycle
              mov       ctrb, ctrval
              movs      ctrb, dacRpin
              mov       frqb, #1
              'set up wait
              mov       time, cnt      'record current time
              add       time, period   'establish next period

              
loop
'add all streams(care must be taken not to peek when combining more than 4 sources)
              mov       pL, pLbase
              mov       pR, pRbase
              sub       pR, #2      'pR is incremented once before use
              mov       Racc, #0
              mov       Lacc, #0
              mov       pEnd, pCount
              shl       pEnd, #1
              add       pEnd, pLbase

acumulate
              rdword    Lvalue, pL 
              add       pR, #2
              
              shl       Lvalue, #16
              sar       Lvalue, #16     
              add       Lacc, Lvalue     
              rdword    Rvalue, pR
              add       pL, #2
              
              shl       Rvalue, #16       
              sar       Rvalue, #16
              add       Racc, Rvalue    
                              
              cmp       pL, pEnd                wc, wz
        if_b  jmp       #acumulate

                                         
              add       Racc, Halfword
              add       Lacc, Halfword
              and       Lacc, WordMask
              and       Racc, WordMask
              shr       Racc, #8       '1/4 resolution to allow for adding 4 streams with out peaking
              shr       Lacc, #8
              'and       Racc, valmask
              'and       Lacc, valmask
              waitcnt   time, period     'wait until next period
              neg       phsa, Lacc  
              neg       phsb, Racc
              jmp       #loop            'loop for next cycle       

dacLpin       long 0
dacRpin       long 0
pLbase        long 0
pRbase        long 0
pL            long 0
pR            long 0
pCount        long 1
pEnd          long 0
ctrval        long %00100 << 26 + 0 
period        long 1024               '~78kHz period (_clkfreq / period)
ValMask       long %1_1111_1111
halfword      long $8000
wordmask      long $ffff
invWordMask   long $ffff_0000
time          res 1
Lvalue        res 1
Lacc          res 1
Rvalue        res 1
Racc          res 1 


{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}   